
#include "engine.hh"
#include <stdlib.h>

Engine::Engine(int players) {
  gamestate=NULL;
  numplayers=players;
  player=new Player*[numplayers];
  for (int i=0; i<numplayers; i++) {
    player[i]=NULL;
  }
}

Engine::~Engine() {
 if (gamestate!=NULL) delete gamestate;
  if (player!=NULL) {
    for (int i=0; i<numplayers; i++)
      if (player[i]!=NULL) delete player[i];
    delete player;
  }
}

void Engine::setPlayer(int id, Player* p) {

  if (id>2)
    return;
  
  if (player[id]!=NULL) delete player[id];
  player[id]=p;
  player[id]->setID(id);

}

Player* Engine::getPlayer(int index) {
  if (index<numplayers)
    return player[index];
  else
    return NULL;
}

void Engine::setGameState(GameState* newstate) {
  if (gamestate!=NULL)
    delete gamestate;
  gamestate=newstate;
}

GameState* Engine::getGameState() {
  return gamestate;
}
