
#ifndef GAMESTATE_HH
#define GAMESTATE_HH

#include "position.hh"
#include "gamefield.hh"

class Player;

class GameState {

public:
  GameState() { m_winner=-1; m_eval=0; m_gameover=false; }
  virtual ~GameState(){};
  virtual GameState* duplicate()=0;

  virtual bool performMove(int, Position&)=0;
  virtual long evaluate(int, int)=0;

  virtual bool isGameOver() { return m_gameover; }
  virtual void setGameOver(bool over) { m_gameover=over; }

  virtual void setEval(long eval) { m_eval=eval; }
  virtual long getEval() { return m_eval; }

  virtual bool isFinal(int, int)=0;

  virtual GameField* getField()=0;
  virtual Position* getAllowedMoves(int &)=0;
  virtual int getAllowedCount()=0;

  virtual int getWinner() { return m_winner; }
  virtual void setWinner(int w) { m_winner=w; m_gameover=true; }
private:
  int m_winner;
  long m_eval;
  bool m_gameover;
};

#endif
