
#ifndef GTKFIELDVIEW_HH
#define GTKFIELDVIEW_HH

#include <gtk--/style.h>
#include <gtk--/drawingarea.h>
#include <game/gamefield.hh>


class GtkFieldView  : public Gtk::DrawingArea
{
  /* Backing pixmap for drawing area */
  Gdk_Pixmap pixmap;
  Gdk_GC gc;
  Gdk_Window win;
  Gdk_Visual visual;

  GameField *field;
  int cellw;
  bool gameend;

public:
  void setGameField(GameField *);
  void gameStateChange(int, int);
  void gameEnd();
  void calculateCell(int, int);
  
  void clear();

  virtual gint configure_event_impl (GdkEventConfigure *event);
  virtual gint expose_event_impl (GdkEventExpose *event);
  virtual gint button_press_event_impl (GdkEventButton *event);
  virtual gint button_release_event_impl (GdkEventButton *event);

  void draw_curve();

public:
  GtkFieldView ();
  ~GtkFieldView();
  SigC::Signal2<void,int,int> positionClicked;
  
  void paintField();
};


#endif
