#include <config.h>

#include <stdio.h>
#include <stdlib.h>


#ifndef VERSION
#define VERSION "0.0.1"
#endif

#include <player/player.hh>
#include <game/position.hh>
#include <tictactoe/tttstate.hh>

#if defined HAVE_QT
#include <qtui/qtui.hh>
#elif defined HAVE_GTK
#include <gtkui/gtkui.hh>
#else
#include <consoleui/consoleui.hh>
#endif

/* 
 * Vstopna tocka v program.
 */
int main(int argc, char** argv) {
  
  printf("Dick %s\n", VERSION);

#if defined HAVE_QT

  QtUI *qtui=new QtUI();
  qtui->run(argc, argv);
  delete qtui;
  
#elif defined HAVE_GTK

  GtkUI *gtkui=new GtkUI();
  gtkui->run(argc, argv);
  delete gtkui;

#else

  UserInterface *ui=new ConsoleUI();  

  ui->run();

  delete ui;
  return 0;

#endif
}


