
#ifndef PLAYER_HH
#define PLAYER_HH

#include <game/gamestate.hh>
#include <game/position.hh>

class Player {
  
public:
  /// Privzeti konstruktor
  Player(int id=-1);
  /// Privzeti destruktor
  ~Player();

  /// Nastavi id igralca
  void setID(int);
  /// Vrni id igralca
  int getID();

  /// Nastavi AI igralca
  void setAI(bool);
  /// Vrni AI igralca
  bool getAI();

  /// Nastavi globino iskanja
  void setBrainsize(int);
  int getBrainsize();

  /// Vrni ime igralca
  char* getName();
  /// Nastavi ime igralca
  void setName(char*);

  /// Pristej tocke k rezultatu 
  void incrementScore(long by=1);
  /// Vrne rezultat
  long getScore();
  /// Ponastavi stevilo tock
  void resetScore();

  /// Dobi naslednjo potezo
  Position getMove(GameState *);
  Position getMoveMinimax(GameState *, int depth=0);
  Position getMoveAlphaBeta(GameState *, long alpha, long beta, int depth=0);

  //  void printField(GameField*);

protected:
  
private:
  /// Kazalec na ime igralca
  char* m_name;
  /// Rezultat
  long m_score;
  /// ID
  int m_id;
  /// Ali je UI?
  bool m_amai;
  /// Brainsize
  int m_brainsize;
};

#endif
