#include "dickless.hh"
#include "playersdialogimpl.hh"
#include <stdlib.h>

#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qstatusbar.h>
#include <qscrollview.h>
#include <qmessagebox.h>
#include <qfont.h>
#include <qlayout.h>

#include <iostream.h>
#include <game/position.hh>
#include <player/player.hh>
#include <tictactoe/tttstate.hh>
#include <fourinrow/fourstate.hh>
#include <string.h>

QDickless::QDickless(QWidget *parent, const char *name)
  : QMainWindow(parent, name), engine(2)
{
  QPopupMenu *game=new QPopupMenu(this);
  menuBar()->insertItem("&Game", game);
  game->insertItem("&Tic-Tac-Toe", this, SLOT(ttt()));
  game->insertItem("&Four in a row", this, SLOT(four()));
  game->insertSeparator();
  game->insertItem("&Settings", this, SLOT(playersMenu()));
  game->insertSeparator();
  game->insertItem("&Quit", this, SLOT(close()));

  QPopupMenu * help = new QPopupMenu( this );
  menuBar()->insertSeparator();
  menuBar()->insertItem( "&Help", help );
  help->insertItem( "&About", this, SLOT(about()), Key_F1 );

  fieldview=new QFieldView(this, "fieldView");
  connect(fieldview, SIGNAL(positionClicked(int, int)), this, SLOT(positionClicked(int, int)));
  connect(this, SIGNAL(performMove(int, int)), this, SLOT(positionClicked(int, int)));
  connect(this, SIGNAL(gameStateChange(int, int)), fieldview, SLOT(gameStateChange(int, int)));
  connect(this, SIGNAL(gameEnd()), fieldview, SLOT(gameEnd()));
  connect(this, SIGNAL(switchPlayer()), this, SLOT(nextPlayer()));
  
  setCentralWidget(fieldview);
  statusBar()->message( "Ready", 2000 );
  resize( 450, 600 );

  currplayer=0;
}

QDickless::~QDickless() 
{

}

void QDickless::about()
{
  QMessageBox::about(this, "Dick Q. Less",
		      "This is the QT Version of\n"
		      "Dick");
}

void QDickless::playersMenu() {

  Player *p1=engine.getPlayer(0), *p2=engine.getPlayer(1);
  
  QPlayersDialogImpl *players=new QPlayersDialogImpl(this, "playerdialog", TRUE);
  players->setPlayers(p1, p2);
  players->show();
  
  if (players->result()) {
    engine.setPlayer(0, players->p1);
    engine.setPlayer(1, players->p2);
  }
}

void QDickless::nextPlayer() {
  if (engine.getGameState()==NULL) {
    repaint();
    return;
  }

  currplayer=!currplayer;
  Player *p=engine.getPlayer(currplayer);
  if (p->getAI()) {
    Position move=p->getMove(engine.getGameState());
    emit performMove(move.getW(), move.getH());
  }
}

void QDickless::positionClicked(int col, int row) {

  Position pos(row, col);
  GameState *gs=engine.getGameState();

  if (gs->performMove(engine.getPlayer(currplayer)->getID(), pos)) {
    emit gameStateChange(pos.getH(), pos.getW());
    if (gs->isFinal(0, 1) || gs->getAllowedCount()==0) {
      QString str("Player ");
      if (gs->getWinner()<2) {
	str+=engine.getPlayer(gs->getWinner())->getName();
	str+=" wins!";
      } else {
	str="Game is a draw!";
      }
      QMessageBox::information(this, "Game over", str);
      emit gameEnd();
      fieldview->setGameField(NULL);
      engine.setGameState(NULL);
    }
    emit switchPlayer();
  } else {
    cout << "invalid move col " << col << " row " << row << "\n";
  }
}


void QDickless::ttt() {
  if (engine.getPlayer(0)==NULL || engine.getPlayer(1)==NULL) {
    playersMenu();
  }
  if (engine.getGameState()==NULL || QMessageBox::information(this, "Looser", "This will end your current game", 
							      "&Ok", "&Cancel", NULL, 0, 1)==0) {
    engine.setGameState(new TTTState());
    fieldview->setGameField(engine.getGameState()->getField());
    nextPlayer();
  }
}

void QDickless::four() {
  if (engine.getPlayer(0)==NULL || engine.getPlayer(1)==NULL) {
    playersMenu();
  }
  if (engine.getGameState()==NULL || QMessageBox::information(this, "Looser", "This will end your current game", 
							      "&Ok", "&Cancel", NULL, 0, 1)==0) { 
    engine.setGameState(new FourState());   
    fieldview->setGameField(engine.getGameState()->getField());
    nextPlayer();
  }
}
