
#ifndef FIELDVIEW_H
#define FIELDVIEW_H

#include <qwidget.h>
#include <qpixmap.h>
#include <game/gamefield.hh>

class QFieldView : public QWidget {
  Q_OBJECT
public:
  QFieldView(QWidget *parent=0, const char *name=0);
  
  QSizePolicy sizePolicy() const;
  
  void setGameField(GameField *);
public slots:
void gameStateChange(int, int);
  void gameEnd();

  signals:
void positionClicked(int, int);
  
protected:
  void paintEvent(QPaintEvent *);
  void paintField(QPaintEvent *);
  void mousePressEvent(QMouseEvent *);
  void mouseReleaseEvent(QMouseEvent *); 
  void resizeEvent(QResizeEvent *);

private:
  // buffer
  QPixmap pixmap;
  // my field
  GameField *field;
  int cellw;
  bool gameend;

  void calculateCell(int, int);
};

#endif // CANNON_H
