#include "playersdialogimpl.hh"

#include <qlineedit.h>
#include <qslider.h>
#include <qcheckbox.h>
/* 
 *  Constructs a QPlayersDialogImpl which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
QPlayersDialogImpl::QPlayersDialogImpl( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QPlayersDialog( parent, name, modal, fl )
{
}

/*  
 *  Destroys the object and frees any allocated resources
 */
QPlayersDialogImpl::~QPlayersDialogImpl()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 * Set players
 */
void QPlayersDialogImpl::setPlayers(Player *p1, Player *p2) {
  if (p1!=NULL) {
    name1->setText(p1->getName());
    human1->setChecked(!p1->getAI());
    skill1->setValue(p1->getBrainsize());
  }
  if (p2!=NULL) {
    name2->setText(p2->getName());
    human2->setChecked(!p2->getAI());
    skill2->setValue(p2->getBrainsize());
  }
}

/* 
 * public slot
 */
void QPlayersDialogImpl::applyChanges()
{
  p1=new Player();

  p1->setName(strdup(name1->text()));
  p1->setAI(!human1->isChecked());
  p1->setBrainsize(skill1->value());

  p2=new Player();

  p2->setName(strdup(name2->text()));
  p2->setAI(!human2->isChecked());
  p2->setBrainsize(skill2->value());
}
